/////////////////////////////////////////////////////////////////////////////
//
// main.cpp - C/C++ zdrojov kd 
//
// (C) Radek Chalupa, 2002 - www.radekchalupa.cz
//
/////////////////////////////////////////////////////////////////////////////

#include "main.h"

#define _MainClassName TEXT("WinAPIMainClass")
#define _AppName TEXT("Ume se WinAPI")
#define _TimerClock 1

HINSTANCE g_hInstance;
HWND g_hwndMain;
HWND g_hwndEnd;
HWND g_hwndButton1;
HWND g_hwndEdit;
HWND g_hwndStatusBar;

void centerText(HDC hdc)
{
	RECT rect;
	GetClientRect(g_hwndMain, &rect);
	SetBkMode(hdc, TRANSPARENT);
	DrawText(hdc, TEXT("Ji mme vlastn ikonu a kurzor!"), -1, &rect,
		DT_SINGLELINE | DT_CENTER | DT_VCENTER);
}

void pozadiTextu(HDC hdc)
{
	TCHAR chText[100];
	lstrcpy(chText, TEXT("Modr barva psma..."));
	SetTextColor(hdc, 0x00FF0000); // modr text
	TextOut(hdc, 10, 10, chText, lstrlen(chText));

	SetBkColor(hdc, 0x0000FFFF); // lut pozad
	lstrcpy(chText, TEXT("Zmnme pozad, psmo zstv..."));
	TextOut(hdc, 10, 40, chText, lstrlen(chText));

	lstrcpy(chText, TEXT("Konen mme prhledn text !!!"));
	SetBkMode(hdc, TRANSPARENT); // prhlednost textu
	TextOut(hdc, 10, 70, chText, lstrlen(chText));

	lstrcpy(chText, TEXT("Pokraovn pt ..."));
	SetTextColor(hdc, 0x000000FF); // modr text
	TextOut(hdc, 10, 110, chText, lstrlen(chText));
}

void OnWM_PAINT()
{
	PAINTSTRUCT ps;
	HDC hdc;
	hdc = BeginPaint(g_hwndMain, &ps);
	centerText(hdc);
	DrawIcon(hdc, 10,10,
		(HICON)(ULONG_PTR)GetClassLongPtr(g_hwndMain, GCLP_HICON));
	EndPaint(g_hwndMain, &ps);
}

void VlastniKresleni(WPARAM wParam, LPARAM lParam)
{
	POINTS ptCursor;
	HDC hdc;
	TCHAR chText[30];
	ptCursor = MAKEPOINTS(lParam);
	_stprintf(chText, TEXT("x=%d, y=%d"), ptCursor.x, ptCursor.y);
	hdc = GetDC(g_hwndMain);
	if ( wParam & MK_CONTROL )
		SetTextColor(hdc, 0x000000FF);
	TextOut(hdc, ptCursor.x, ptCursor.y, chText, lstrlen(chText));
	ReleaseDC(g_hwndMain, hdc);
}

void KresleniDoTitulku(WPARAM wParam, LPARAM lParam)
{
	POINTS ptCursor;
	HDC hdc;
	TCHAR chText[30];
	ptCursor = MAKEPOINTS(lParam);
	_stprintf(chText, TEXT("x=%d, y=%d"), ptCursor.x, ptCursor.y);
	hdc = GetWindowDC(g_hwndMain);
	if ( wParam & MK_CONTROL )
		SetTextColor(hdc, 0x000000FF);
	TextOut(hdc, 150, 8, chText, lstrlen(chText));
	ReleaseDC(g_hwndMain, hdc);
}

void OnWM_MOUSEMOVE(WPARAM wParam, LPARAM lParam)
{
	POINTS ptCursor;
	TCHAR chText[30];
	ptCursor = MAKEPOINTS(lParam);
	_stprintf(chText, TEXT("x=%d, y=%d"), ptCursor.x, ptCursor.y);
	SetWindowText(g_hwndMain, chText);
}

INT_PTR CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	TCHAR chText[200];
	switch ( uMsg )
	{
case WM_INITDIALOG:
	SendDlgItemMessage(hwndDlg, IDC_SLEDOVAT, BM_SETCHECK, BST_CHECKED, 0);
	break;
		case WM_COMMAND:
			switch ( LOWORD(wParam) )
			{
				case IDOK:
					EndDialog(hwndDlg, IDOK);
					break;
				case IDCANCEL:
					EndDialog(hwndDlg, IDCANCEL);
					break;
				case IDC_ZOBRAZ_TEXT:
					GetDlgItemText(hwndDlg, IDC_EDIT1, chText, 200);
					SendMessage(g_hwndMain, WM_SETTEXT, 0, (LPARAM)chText);
					break;
				case IDC_EDIT1:
					if ( HIWORD(wParam) == EN_CHANGE )
					{
						if ( SendDlgItemMessage(hwndDlg, IDC_SLEDOVAT, BM_GETCHECK, 0,0) == BST_CHECKED )
						{
							GetDlgItemText(hwndDlg, IDC_EDIT1, chText, 200);
							SetDlgItemText(hwndDlg, IDC_KOPIE, chText);
						}
					}
					break;
			}
			break;
	}
	return FALSE;
}

LRESULT CALLBACK WindowProcMain(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	TCHAR chText[200];
	SYSTEMTIME sysTime;
	INT_PTR dlgResult;
	switch ( message )
	{
		case WM_CLOSE:
			if ( MessageBox(hwnd, TEXT("Opravdu konit?"), _AppName,
				MB_YESNO | MB_ICONQUESTION | MB_TASKMODAL) != IDYES )
				return 0;
			KillTimer(hwnd, _TimerClock);
			break;
		case WM_COMMAND:
			switch ( LOWORD(wParam) )
			{
				case ID_ABOUT:
					MessageBox(hwnd, TEXT("Win API demo dl 10.\n\nRadek Chalupa, 2002"),
						TEXT("O programu WinApi demo"), MB_ICONINFORMATION);
					break;
				case ID_END:
					SendMessage(hwnd, WM_CLOSE, 0, 0);
					DestroyWindow(hwnd);
					break;
				case ID_SHOW_DIALOG:
					dlgResult = DialogBox(g_hInstance, MAKEINTRESOURCE(IDD_DIALOG1),
						hwnd, (DLGPROC)DialogProc);
					if ( dlgResult == IDOK )
						MessageBox(hwnd, "Dialog ukonen OK", "Dialog", MB_ICONINFORMATION);
					else
						MessageBox(hwnd, "Dialog ukonen Cancel", "Dialog", MB_ICONEXCLAMATION);
					break;
			}
			if ( lParam == (LPARAM)g_hwndButton1 )
			{
				GetWindowText(g_hwndEdit, chText, 200);
				MessageBox(g_hwndMain, chText, TEXT("Obsah editanho pole"), MB_ICONINFORMATION);
			}
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		case WM_MOUSEMOVE:
//			OnWM_MOUSEMOVE(wParam, lParam);
			break;
		case WM_LBUTTONDOWN:
//			KresleniDoTitulku(wParam, lParam);
			break;
		case WM_PAINT:
//			OnWM_PAINT();
			break;
		case WM_SIZE:
			SendMessage(g_hwndStatusBar, WM_SIZE, wParam, lParam);
			break;
		case WM_TIMER:
			GetLocalTime(&sysTime);
			_stprintf(chText, TEXT(" Dnes je: %d.%d.%d, %d:%.2d:%.2d hod."),
				sysTime.wDay, sysTime.wMonth, sysTime.wYear,
				sysTime.wHour, sysTime.wMinute, sysTime.wSecond);
			SetWindowText(g_hwndStatusBar, chText);
			break;
	}
	return DefWindowProc(hwnd, message, wParam, lParam);
}

TCHAR ch[20];

BOOL InitApp()
{
	INITCOMMONCONTROLSEX icc;
	icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
	icc.dwICC = ICC_WIN95_CLASSES;
	if ( !InitCommonControlsEx(&icc) )
		return FALSE;
	WNDCLASSEX wc;
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1);
	wc.hCursor = LoadCursor(g_hInstance, MAKEINTRESOURCE(IDC_MAIN));
	wc.hIcon = LoadIcon(g_hInstance, MAKEINTRESOURCE(IDR_MAIN));
	wc.hIconSm = LoadIcon(g_hInstance, MAKEINTRESOURCE(IDR_MAIN));
	wc.hInstance = g_hInstance;
	wc.lpfnWndProc = WindowProcMain;
	wc.lpszClassName = _MainClassName;
//	wc.lpszMenuName = MAKEINTRESOURCE(IDR_MAINMENU);
	wc.lpszMenuName = NULL;
	wc.style = CS_HREDRAW | CS_VREDRAW;
	if ( !RegisterClassEx(&wc) )
		return FALSE;

	g_hwndMain = CreateWindowEx(0, _MainClassName,
		_AppName,
		WS_OVERLAPPEDWINDOW | WS_VISIBLE,
		100, 100, 350, 250,
		NULL, 
		LoadMenu(g_hInstance, MAKEINTRESOURCE(IDR_MAINMENU)),
		g_hInstance, NULL);
	if ( g_hwndMain == NULL )
		return FALSE;

// vytvoen dtskch oken
	g_hwndEdit = CreateWindowEx(WS_EX_CLIENTEDGE,
		TEXT("EDIT"),
		TEXT("editan pole"),
		WS_CHILD | WS_VISIBLE | ES_LEFT,
		10, 15, 200, 25,
		g_hwndMain,
		(HMENU)NULL,
		g_hInstance,
		NULL);
	if ( g_hwndEdit == NULL )
		return FALSE;

	g_hwndButton1 = CreateWindowEx(0,
		TEXT("BUTTON"),
		TEXT("Text?"),
		WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
		10, 50, 75, 25,
		g_hwndMain,
		(HMENU)NULL,
		g_hInstance,
		NULL);
	if ( g_hwndButton1 == NULL )
		return FALSE;

	g_hwndEnd = CreateWindowEx(0,
		TEXT("BUTTON"),
		TEXT("Konec"),
		WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
		95, 50, 75, 25,
		g_hwndMain,
		(HMENU)ID_END,
		g_hInstance,
		NULL);
	if ( g_hwndEnd == NULL )
		return FALSE;
		
	g_hwndStatusBar = CreateWindowEx(0,
		STATUSCLASSNAME,
		TEXT("Stavov dek"),
		WS_CHILD | WS_VISIBLE,
		0, 0, 0, 0,
		g_hwndMain,
		(HMENU)NULL,
		g_hInstance,
		NULL);
	if ( g_hwndStatusBar == NULL )
		return FALSE;
		
	HFONT hFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
	SendMessage(g_hwndEdit, WM_SETFONT, (WPARAM)hFont, (LPARAM)TRUE);
	SendMessage(g_hwndButton1, WM_SETFONT, (WPARAM)hFont, (LPARAM)TRUE);
	SendMessage(g_hwndEnd, WM_SETFONT, (WPARAM)hFont, (LPARAM)TRUE);
	SetTimer(g_hwndMain, _TimerClock, 1000, NULL);
	SendMessage(g_hwndMain, WM_TIMER, _TimerClock, NULL);

DialogBox(g_hInstance, MAKEINTRESOURCE(IDD_DIALOG1),	g_hwndMain, (DLGPROC)DialogProc);
	return TRUE;
}

MSG msg;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nShow)
{
	g_hInstance = hInstance;
	if ( !InitApp() )
		return FALSE;
	while ( GetMessage(&msg, NULL, 0, 0) )
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}
